package ij2x.plugin;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.Graphics;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;

import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.swing.AbstractButton;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JPanel;

import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.Menus;
import ij.plugin.PlugIn;
import ij.WindowManager;

import ij2x.util.ResourceString;
import ij2x.util.BorderlessButton;
import ij2x.util.AWTImages;
import ij2x.util.ImageIcons;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ImageTypePanel extends JPanel implements PlugIn, ActionListener, ChangeListener, MouseListener, MouseMotionListener, PropertyChangeListener {

    protected ImagePlus imp;
    protected ImageJ ij;
    public JButton infoButton, draggedButton, closeButton, undecoratedButton;
    protected JButton gray8Button, gray16Button, rgb8Button, gray32Button, rgbButton;
    public static JCheckBox g8CheckBox, g16CheckBox, rgb8CheckBox, g32CheckBox, rgbCheckBox;
    private AbstractButton action;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = null;//BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);
    private int actionCount = 0;
    private static int current;
    private long mouseDownTime;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel controlBarPanel=new JPanel();
    public JPanel panel=new JPanel();
    private GridBagLayout gblayout = new GridBagLayout();
    private Boxlayout g8layout = new Boxlayout();
    private Boxlayout g16layout = new Boxlayout();
    private Boxlayout g32layout = new Boxlayout();
    private Boxlayout rgb8layout = new Boxlayout();
    private Boxlayout rgb32layout = new Boxlayout();
    private ButtonGroup group = new ButtonGroup();
    public static ImageTypePanel instance;
    private static ResourceBundle resources;
    private int index = 0;

    static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.ImagetypeBar",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("resources/ImagetypeBar.properties not found");
            System.exit(1);
        }
    }


    public ImageTypePanel() {
        ImageTypePanel.instance = this;
    }
    public void run(String arg){
        ij = IJ.getInstance();
        controlBarPanel=createControlBar();
    }

    public JPanel createControlBar(){

        imp = WindowManager.getCurrentImage();
        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);
        ImageIcon b1o = (ImageIcon)ImageIcons.getIcons(this);

        AWTImages.setImageDir("typeDir");


    String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "typebar"));

    Image[][] icons = new Image[iconAllName.length][3];
    for(int i=0; i < iconAllName.length; i++){
        for(int j=0; j < 3; j++){
            icons[i][j]=((ImageIcon)AWTImages.createBufferedIcon(
                    this
                      , ResourceString.tokenize(ResourceString.getResourceString(resources, iconAllName[i]))[j]
                        , b1o.getImage()
                          , 24)).getImage();
        }
    }

        gray8Button=BorderlessButton.createButton(this, gray8Button, "Gray 8 Bit", icons[index++]);

        g8CheckBox= createChechBox(g8CheckBox, "Gray 8 Bit CheckBox");
        g8CheckBox.setSelected(Menus.gray8Item.getState());
        g8layout.add(g8CheckBox);
        g8layout.add(gray8Button);
        g8layout.setBorder(lightGrayBorder);

        gray16Button=BorderlessButton.createButton(this, gray16Button, "Gray 16 Bit", icons[index++]);

        g16CheckBox= createChechBox(g8CheckBox, "Gray 16 Bit CheckBox");
        g16CheckBox.setSelected(Menus.gray16Item.getState());
        g16layout.add(g16CheckBox);
        g16layout.add(gray16Button);
        g16layout.setBorder(lightGrayBorder);

        gray32Button=BorderlessButton.createButton(this, gray32Button, "Gray 32 Bit", icons[index++]);

        g32CheckBox= createChechBox(g8CheckBox, "Gray 32 Bit CheckBox");
        g32CheckBox.setSelected(Menus.gray32Item.getState());
        g32layout.add(g32CheckBox);
        g32layout.add(gray32Button);
        g32layout.setBorder(lightGrayBorder);

        rgb8Button=BorderlessButton.createButton(this, rgb8Button, "RGB 8-Bit Color", icons[index++]);

        rgb8CheckBox= createChechBox(g8CheckBox, "RGB 8-Bit Color CheckBox");
        rgb8CheckBox.setSelected(Menus.color256Item.getState());
        rgb8layout.add(rgb8CheckBox);
        rgb8layout.add(rgb8Button);
        rgb8layout.setBorder(lightGrayBorder);

        rgbButton=BorderlessButton.createButton(this, rgbButton, "RGB Color", icons[index++]);

        rgbCheckBox= createChechBox(g8CheckBox, "RGB Color CheckBox");
        rgbCheckBox.setSelected(Menus.colorRGBItem.getState());
        rgb32layout.add(rgbCheckBox);
        rgb32layout.add(rgbButton);
        rgb32layout.setBorder(lightGrayBorder);

        infoButton=BorderlessButton.createButton(this, infoButton, "Show Info ...", icons[index]);


        group.add(g8CheckBox);
        group.add(g16CheckBox);
        group.add(g32CheckBox);
        group.add(rgb8CheckBox);
        group.add(rgbCheckBox);

        panel.add(g8CheckBox);
        panel.add(gray8Button);
        panel.add(g16CheckBox);
        panel.add(gray16Button);
        panel.add(g32CheckBox);
        panel.add(gray32Button);
        panel.add(rgb8CheckBox);
        panel.add(rgb8Button);
        panel.add(rgbCheckBox);
        panel.add(rgbButton);
        panel.add(infoButton);

        if (imp==null)
                //{IJ.noImage(); enableCheckBox(false); return panel;}
                //else{enableCheckBox(true);updateState();}
                {IJ.noImage(); return panel;}
                else{updateState();}
        return panel;
     }


     private JCheckBox createChechBox(JCheckBox action, String tooltip){
         action = new JCheckBox();
         action.setToolTipText(tooltip);
         action.addActionListener(this);
         action.addMouseListener(this);
         action.addMouseMotionListener(this);
         action.setRolloverEnabled(false);
     return action;
     }

     void setButtonDim(JButton action, Dimension maxDim, Dimension preDim, Dimension minDim){
       action.setMaximumSize(maxDim);
       action.setPreferredSize(preDim);
       action.setMinimumSize(minDim);
   }
    void setButtonDim(JButton action, Dimension[] allDim){
      action.setMaximumSize(allDim[0]);
      action.setPreferredSize(allDim[1]);
      action.setMinimumSize(allDim[2]);
 }

     void setBorderlessButton(JButton button){
           button.setMargin(new Insets(0, 0, 0, 0));
           button.setBorderPainted(false);
           button.setContentAreaFilled(false);
           button.setFocusPainted(false);
       }

       public void setMoviePanel(boolean isMoviepanel){
       //movieJPanel.setVisible(isMoviepanel);
       }

       public void setButtonPanel(boolean isButtonpanel){
       //panel.setVisible(isButtonpanel);
       }
       public void propertyChange(PropertyChangeEvent e){

       }
       public void stateChanged(ChangeEvent e){
       }

       public void mousePressed(MouseEvent e) {
           Object ab = e.getSource();
           if(ab instanceof JButton)
           action = (JButton)ab;
       if(ab instanceof JCheckBox)
       action = (JCheckBox)ab;
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}
        public void mouseMoved(MouseEvent e) {
            AbstractButton action = null;
            Object ab = e.getSource();
            if(ab instanceof JButton)
            action = (JButton)ab;
        if(ab instanceof JCheckBox)
        action = (JCheckBox)ab;
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!false) {
                     if(action == gray8Button || action == g8CheckBox ){
                         IJ.showStatus("Command: 8-bit");
                     }
                     else if(action == gray16Button || action == g16CheckBox){
                         IJ.showStatus("Command: 16-bit");
                     }
                     else if(action == gray32Button || action == g32CheckBox ){
                         IJ.showStatus("Command: 32-bit");
                     }
                     else if(action == rgb8Button || action == rgb8CheckBox ){
                         IJ.showStatus("Command: 8-bit Color");
                     }
                     else if(action == rgbButton || action == rgbCheckBox){
                         IJ.showStatus("Command: RGB Color");
                     }
                     else if(action == infoButton){
                        IJ.showStatus("Command: Show Info...");
                    }
                    else if (action == draggedButton) {
                         IJ.showStatus("Move...");
                     }
                     else if (action == closeButton) {
                         IJ.showStatus("Decorated Frame");
                     }
                     else if (action == undecoratedButton) {
                         IJ.showStatus("Undecorated Frame");
                     }

                 }
        }
        public void actionPerformed(ActionEvent e){
            imp = WindowManager.getCurrentImage();
            if (imp==null)
                    //{enableCheckBox(false);updateState(); return;}
                    //else{enableCheckBox(true);
                        {updateState(); return;}
                        else{
                        try {
                            if (action == gray8Button || action == g8CheckBox) {
                                IJ.runPlugIn("ij.plugin.Converter", "8-bit");
                                g8CheckBox.setSelected(true);
                            } else if (action == gray16Button ||
                                       action == g16CheckBox) {
                                IJ.runPlugIn("ij.plugin.Converter", "16-bit");
                                g16CheckBox.setSelected(true);
                            } else if (action == gray32Button ||
                                       action == g32CheckBox) {
                                IJ.runPlugIn("ij.plugin.Converter", "32-bit");
                                g32CheckBox.setSelected(true);
                            } else if (action == rgb8Button ||
                                       action == rgb8CheckBox) {
                                IJ.runPlugIn("ij.plugin.Converter",
                                             "8-bit Color");
                                rgb8CheckBox.setSelected(true);
                            } else if (action == rgbButton ||
                                       action == rgbCheckBox) {
                                IJ.runPlugIn("ij.plugin.Converter", "RGB Color");
                                rgbCheckBox.setSelected(true);
                            } else if (action == infoButton) {
                                IJ.doCommand("Show Info...");
                            }
                        } catch (Exception ex) {

                        }
                        updateState();
                    }
        }

        public static void updateState(){
           g8CheckBox.setSelected(Menus.gray8Item.getState());
           g16CheckBox.setSelected(Menus.gray16Item.getState());
           g32CheckBox.setSelected(Menus.gray32Item.getState());
           rgb8CheckBox.setSelected(Menus.color256Item.getState());
           rgbCheckBox.setSelected(Menus.colorRGBItem.getState());
       }

        /**
         * FIXME - I'm not very useful yet
         */
        /**/public class Boxlayout extends JComponent {

            public Boxlayout() {
                super();
                setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
            }
            public void update(Graphics g){
                paint(g);
            }

            public void paint(Graphics g) {
                super.paint(g);
            }

        }

}
