package ij2x.plugin;

import java.awt.Color;
import java.awt.Image;

import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.Border;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.plugin.PlugIn;
import ij.gui.Roi;

import ij2x.util.BorderlessButton;
import ij2x.util.ResourceString;
import ij2x.util.ImageIcons;
import ij2x.util.AWTImages;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

public class OverlayPanel extends JPanel implements PlugIn, ActionListener, MouseListener, MouseMotionListener {

    protected ImagePlus imp;
    protected ImageJ ij;
    public JButton infoButton;
    protected JButton addOverlayButton, removeOverlayButton, showOverlayButton, hideOverlayButton, optionOverlayButton,
            imageButton, fromROIMButton, toROIMButton, flattenButton, labelsButton
                    , fillButton, openArbitraryButton, ROIMButton, undoButton, colorpickerButton
                    , forwardPlayButton, backwardPlayButton, splineButton;
    private JButton action;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);

    private static int current;
    private long mouseDownTime;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel controlBarPanel=new JPanel();
    public JPanel panel=new JPanel();
    private static ResourceBundle resources;
    private int index = 0;
    private Roi roi;

    static {
        try {
            resources = ResourceBundle.getBundle("ij2x.plugin.resources.OverlayBar",
                                                 Locale.getDefault());
        } catch (MissingResourceException mre) {
            System.err.println("resources/OverlayBar.properties not found");
            System.exit(1);
        }
    }

    public OverlayPanel() {
    }
    public void run(String arg){
        ij = IJ.getInstance();
        controlBarPanel=createControlBar();
    }

    public JPanel createControlBar(){

        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);

        ImageIcon b1o = (ImageIcon)ImageIcons.getIcons(this);

        AWTImages.setImageDir("overlayDir");


    String[] iconAllName = ResourceString.tokenize(ResourceString.getResourceString(resources, "overlaybar"));

    Image[][] icons = new Image[iconAllName.length][3];
    for(int i=0; i < iconAllName.length; i++){
        for(int j=0; j < 3; j++){
            icons[i][j]=((ImageIcon)AWTImages.createBufferedIcon(
                    this
                      , ResourceString.tokenize(ResourceString.getResourceString(resources, iconAllName[i]))[j]
                        , b1o.getImage()
                          , 24)).getImage();
        }
    }
    addOverlayButton=BorderlessButton.createButton(this, addOverlayButton, "Add Overlay", icons[index++]);

    removeOverlayButton=BorderlessButton.createButton(this, removeOverlayButton, "Remove Overlay", icons[index++]);

    showOverlayButton=BorderlessButton.createButton(this, showOverlayButton, "Show Overlay", icons[index++]);

    hideOverlayButton=BorderlessButton.createButton(this, hideOverlayButton, "Hide Overlay", icons[index++]);

    optionOverlayButton=BorderlessButton.createButton(this, optionOverlayButton, "Overlay Options", icons[index++]);

    infoButton=BorderlessButton.createButton(this, infoButton, "Show Info ...", icons[index++]);

    imageButton=BorderlessButton.createButton(this, imageButton, "Add Image", icons[index++]);

    labelsButton=BorderlessButton.createButton(this, labelsButton, "Add Labels", icons[index++]);

    flattenButton=BorderlessButton.createButton(this, flattenButton, "Flatten", icons[index++]);

    fromROIMButton=BorderlessButton.createButton(this, fromROIMButton, "From ROI-Manager", icons[index++]);

    toROIMButton=BorderlessButton.createButton(this, toROIMButton, "To ROI-Manager", icons[index++]);

    openArbitraryButton=BorderlessButton.createButton(this, openArbitraryButton, "Open Arbitrary", icons[index++]);

    forwardPlayButton=BorderlessButton.createButton(this, forwardPlayButton, "Open Forward", icons[index++]);

    backwardPlayButton=BorderlessButton.createButton(this, backwardPlayButton, "Open Backward", icons[index++]);

    fillButton=BorderlessButton.createButton(this, fillButton, "Fill Overlay Roi", icons[index++]);

    ROIMButton=BorderlessButton.createButton(this, ROIMButton, "ROI-Manager", icons[index++]);

    undoButton=BorderlessButton.createButton(this, undoButton, "Undo Action", icons[index++]);
    
    colorpickerButton=BorderlessButton.createButton(this, colorpickerButton, "JColor Pane", icons[index++]);

    splineButton=BorderlessButton.createButton(this, splineButton, "Fit Spline", icons[index]);
    

        panel.add(addOverlayButton);
        panel.add(removeOverlayButton);
        panel.add(fillButton);
        panel.add(undoButton);
        panel.add(colorpickerButton);
        panel.add(splineButton);
        panel.add(showOverlayButton);
        panel.add(hideOverlayButton);
        panel.add(fromROIMButton);
        panel.add(ROIMButton);
        panel.add(toROIMButton);
        panel.add(imageButton);
        panel.add(flattenButton);
        //panel.add(openArbitraryButton);
        //panel.add(forwardPlayButton);
        //panel.add(backwardPlayButton);
        panel.add(labelsButton);
        panel.add(optionOverlayButton);

        panel.add(infoButton);
        return panel;
     }

       public void mousePressed(MouseEvent e) {
           action = (JButton)e.getSource();
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}

        public void mouseMoved(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 if (!false) {
                     if(action == infoButton){
                         IJ.showStatus("Command: Show Info...");
                     }
                     else if(action == addOverlayButton){
                         IJ.showStatus("Command: Add Selection...[b]");
                     }
                     else if(action == removeOverlayButton){
                         IJ.showStatus("Command: Remove Overlay");
                     }
                     else if(action == showOverlayButton){
                         IJ.showStatus("Command: Show Overlay");
                     }
                     else if(action == hideOverlayButton){
                         IJ.showStatus("Command: Hide Overlay");
                     }
                     else if(action == colorpickerButton){
                         IJ.showStatus("Command: JColor Pane...");
                     }
                     else if(action == splineButton){
                         IJ.showStatus("Command: Fit Spline");
                     }
                     else if(action == optionOverlayButton){
                         IJ.showStatus("Command: Overlay Options...");
                     }
                     else if(action == imageButton){
                         IJ.showStatus("Command: Add Image...");
                     }
                     else if(action == fromROIMButton){
                         IJ.showStatus("Command: From ROI Manager");
                     }
                     else if(action == toROIMButton){
                         IJ.showStatus("Command: To ROI Manager");
                     }
                     else if(action == backwardPlayButton){
                    	 IJ.showStatus("Command: Open Backward");
                     }
                     else if(action == forwardPlayButton){
                    	 IJ.showStatus("Command: Open Forward");
                     }
                     else if(action == flattenButton){
                         IJ.showStatus("Command: Flatten[F]");
                     }
                     else if(action == labelsButton){
                         IJ.showStatus("Command: Labels...");
                     }
                     else if(action == fillButton){
                         IJ.showStatus("Command: Fil ROI");
                     }
                     else if(action == ROIMButton){
                         IJ.showStatus("Command: Roi Manager...");
                     }
                     else if(action == openArbitraryButton){
                         IJ.showStatus("Command: Open Arbitrary");
                     }
                     else if(action == undoButton){
                         IJ.showStatus("Command: Undo");
                     }

                 }
        }
        public void actionPerformed(ActionEvent e){
            try {
                if(action == infoButton){
                    IJ.doCommand("Show Info...");
                }
                else if(action == addOverlayButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "add");
                }
                else if(action == removeOverlayButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "remove");
                }
                else if(action == showOverlayButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "show");
                }
                else if(action == hideOverlayButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "hide");
                }
                else if(action == colorpickerButton){
                    //IJ.runPlugIn("ij2x.plugin.frame.ColorPane", "");
                    IJ.runPlugIn("ij.plugin.frame.ColorPicker", "");
                }
                else if(action == splineButton){
                    IJ.doCommand("Fit Spline");
                }
                else if(action == optionOverlayButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "options");
                }
                else if(action == imageButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "image");
                }
                else if(action == fromROIMButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "from");
                }
                else if(action == toROIMButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "to");
                }
                else if(action == backwardPlayButton){
                    IJ.runPlugIn("ij.plugin.NextImageOpener", "backward");
                }
                else if(action == forwardPlayButton){
                    IJ.runPlugIn("ij.plugin.NextImageOpener", "forward");
                }
                else if(action == flattenButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "flatten");
                }
                else if(action == labelsButton){
                    IJ.doCommand("Labels...");
                    //IJ.runPlugIn("ij.plugin.Clipboard", "scale");
                    //IJ.runPlugIn("ij2x.plugin.frame.MagnifierFrame", "");
                         }
                else if(action == fillButton){
                    IJ.runPlugIn("ij.plugin.OverlayCommands", "fill");
                }
                else if(action == undoButton){
                    IJ.doCommand("Undo");
                }
                else if(action == ROIMButton){
                    IJ.doCommand("ROI Manager...");
                }
                else if(action == openArbitraryButton){
                    //IJ.runPlugIn("ij2x.plugin.frame.JTreeFrame", "");
                }
            } catch (Exception ex) {

            }
        }
}
